from main import *
from model import *
from config import args
import torch as t
from generate import *
import time
import torch.nn as nn
def Inference():
    print("正在初始化......")
    datas = np.load("tang.npz",allow_pickle=True)
    data = datas['data']
    ix2word = datas['ix2word'].item()
    word2ix = datas['word2ix'].item()
    # model = PoetryModel(args, 8400, args.embedding_dim, args.hidden_dim,mpo=args.mpo)
    model = PoetryModel(args)
    model.load_state_dict(t.load(args.model_path, 'cpu'))
    if args.ingpu:
        model.to(args.device)
    print(args.ingpu)
    print(args.device)   
    print("初始化完成！\n")
    data = t.from_numpy(data)[:args.num_train].to(args.device)
    data = data.long().transpose(1,0).contiguous()
    data.to(args.device)
    print(data.device)
    input,target = data[:-1,:],data[1:,:]
    
    criterion = nn.CrossEntropyLoss()
    
    time0=time.time()
    with t.no_grad():
        input.to(args.device)
        target.to(args.device)
        output,_ = model(input)
        loss = criterion(output,target.view(-1))
        print(loss)
    print('used_time',time.time()-time0)
if __name__ == '__main__':
    Inference()    